<?php
ob_start("ob_gzhandler");
set_time_limit(0);  // no time limit to finish script!
require_once('config.php');

$Ltmp = array_flip(array('-','prg','p00'));

echo $html_begin;
echo "<fieldset style='width:600px;'><legend><b>Compare</b></legend>";
echo "<i>-check if there are new/redundant files in a new pack!</i><br><br>";
echo "<b>Directory:</b>".$internal_path;

$dir_list = scandir($internal_path);     
ignorecasesort($dir_list);     
echo "<form name='form_add_pack' action='$PHP_SELF' method='post'>";
echo "<select name='sel_pack'>";
echo "<option disabled value=''>Chose pack to compare</option>";
for ($i=0;$i<sizeOf($dir_list);$i++)
 {
  $dir_entry = $dir_list[$i];
  if ($dir_entry != "." && $dir_entry != "..") 
  {
    if (is_dir($internal_path.$dir_entry)) 
    {
      echo "<option value=\"$dir_entry\">".$dir_entry."</option>";
    }
  }  
 }
echo "</select>";
echo "<input type='submit' name='compare_btn' value='Compare'><br><input type=checkbox name=delete_redudant> Delete redundant files!!!";
echo "<input type=checkbox name=chk_show_info checked> Show detailed info";
echo "<br></form></fieldset>";
ob_flush();flush();sleep(1);

function zplit($str,$chr_val)
{
  // takes a given string $str, and a char_value (0-255)
  // returns the (sub)string until first ord($str[$i])==$chr_val 
  $stop = false;$i= 0;$res = "";          
  while (!$stop)
  {
    $p = substr($str,$i,1);
    if (strcmp(ord($p),$chr_val)<>0) $res .= $p;
    else $stop = true;
    $i++;
    if ($i>strlen($str)) break;            
  }
  return $res;       
}

function traversedir($path, $dir) 
  {
    global $DB;
    global $reduntant;
    global $unique;
    global $total_entries;
    global $imported_entries;
    global $delete_chk;
    global $Lext;
    global $Ltmp;
    
    $k = 0;
    $dir_list = scandir($path.$dir);
    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      $dir_entry = $dir_list[$i];
      if ($dir_entry != "." && $dir_entry != "..") 
      {
        if (is_dir($path.$dir.$dir_entry)) 
        {
          traversedir($path, $dir.$dir_entry.'/');
        }
        else if (is_file($path.$dir.$dir_entry)) 
        {
         $file_extension = strtolower(substr(strrchr($dir_entry,"."),1));
         if ($Lext[$file_extension]) 
         {
          $total_entries += 1;
          // Get md5 of archive(d64, t64, prg...)
          $filename = $path.$dir.$dir_entry;         
          $fp = fopen($filename,'r');
          $file_size = filesize($filename);  
          if ($file_size>0)
          {
          $c64_image = fread($fp,$file_size);
          fclose($fp);
          
          // $md5hash = md5($c64_image);
          if ($file_extension=='p00')
          {
            $md5hash = md5(substr($c64_image, 26, $file_size));
          }
          else if (($file_extension=='lnx') and ($delete_chk))
          {
              $dir_size = zplit(substr($c64_image,96,4), '20');
              $label    = zplit(substr($c64_image,100,40), 13);
              $num_entries = trim(zplit(substr($c64_image,100+strlen($label)+2,4), '13'));
                
              if ($num_entries==1)
              {
                $data_offset = $dir_size * 254; // binary data begins here
                // Get dir elements          
                $dir_start = 100 + strlen($label) + strlen($num_entries) + 4;
                $offset = $dir_start;
                for($j=0;$j<$num_entries;$j++)
                {
                  // $c64_filename = zplit(substr($c64_image,$offset,16),13);    
                  $offset = $offset + 16 + 1;
                  $file_size_B = zplit(substr($c64_image,$offset,5),13);
                  $offset = $offset + 1 + strlen($file_size_B);
                  // $lnx_type = zplit(substr($c64_image,$offset,6),13);
                  $offset = $offset + 2;
                  $LSU_byte = zplit(substr($c64_image,$offset,6),13); // last sector useage                
                  $offset = $offset + 1 + strlen($LSU_byte);
			            $filesize  = (($file_size_B-1)*254)+$LSU_byte-1;
			            $filestart = $data_offset;
			            $fileend   = $filestart + $filesize;
                  $file_entry_md5  = md5(substr($c64_image, $filestart, $filesize));       
                  $data_offset = $data_offset + $file_size_B*254;
                  if ($DB->file_entry_md5_exist($file_entry_md5)<>0)  
                  {
                      @chmod($filename,0777);unlink($filename);
                      echo "<BR>DELETED FILE[LNX]: ".$filename;
                      ob_flush();flush();                               
                  }
                }
              }
          }
          else
          {
            $md5hash = md5($c64_image);
          }
            
            // 1) Check if image already is in database. If not then 
            // 2) check if we have a simple datatype (prg, p00) AND if the data is already in database
            // if still false then we have a new archive                    
            if ( (($DB->disk_md5_exist($md5hash, false, NULL, $dir_entry, $path.$dir))==0) OR (($Ltmp[$file_extension]) AND ($DB->file_entry_md5_exist($md5hash)==0)) )
            {        
              $imported_entries += 1;
              if (!empty($_REQUEST['chk_show_info']))
              {
                $unique .= "<tr><td>".$filename."</td>";
                $unique .= "<td align=center><a target=_BLANK href='view_d64.php?filename=".$filename."'>dir</a></td></tr>";
              }
            }
            else
            {
              if (!empty($_REQUEST['chk_show_info']))
              {
                $SQLlocated_in_packs = $DB->get_packname_disk_md5($md5hash);
                $in_pack = mysql_fetch_array($SQLlocated_in_packs);
                $col = (($k%2)==0) ? " bgcolor=#eeeeee " : " bgcolor=#ffffff ";$k++; 
                $reduntant .= "<tr $col ><td>".$filename."</td>
                                 <td>".$in_pack['disk_reference'].$in_pack['disk_name']."</td>
                                 <td align=center><a target=_BLANK href='view_d64.php?disk_md5=".$md5hash."'>dir$md5hash</a></td>
                                 <td>";
                $SQLlocated_in_packs = $DB->get_packname_disk_md5($md5hash);
                while($in_pack = mysql_fetch_array($SQLlocated_in_packs))
                {              
                  $reduntant .= $in_pack['pack_name']."1<br>";
                }
                $reduntant .= "</td></tr>";
              }
              
              if ($delete_chk)
              {                
                @chmod($filename,0777);unlink($filename);
                echo "<BR>DELETED FILE: ".$filename;
                ob_flush();flush();                               
              }
            }
          }
          else
          {
            fclose($fp); // file_size==0, close file  
          }                 
         }
        }
        else
        {
          echo "<br>!Unknown! : ".$dir.$dir_list[$i]."<br>";
        }
      }  
    } 
  }

$pack_name   = (!empty($_REQUEST['sel_pack'])) ? $_REQUEST['sel_pack'] : null;
$compare_btn = (!empty($_REQUEST['compare_btn'])) ? $_REQUEST['compare_btn'] : null;
$delete_chk  = (!empty($_REQUEST['delete_redudant'])) ? $_REQUEST['delete_redudant'] : null;

if (($compare_btn)  AND ($pack_name))
{ 
    echo "<h3>Pack: $pack_name</h3>";ob_flush();flush();
    $total_entries    = 0;
    $imported_entries = 0;
    $unique    = "<table border=1><th>Filename</th><th>Dir</th>";
    $reduntant = "<table border=1><th>Filename</th><th>Already located here</th><th>Dir</th><th>In these packs</th>";
    $pack_name .= "/";  
    $path = $internal_path.$pack_name;   
    if (is_dir($path))
    {
      traversedir($path,'');
      $redundant .= "</table>";
      echo "<h3>Pack was succesfully compared!</h3>";
      echo "<b>Total unique files:".$imported_entries." out of ".$total_entries."</b><br>";
      $redundant_entries = $total_entries - $imported_entries;
      echo "Redundant files:".$redundant_entries."<br><h3 style='display:inline;'>Redundant files:</h3>".$reduntant."</table><hr><h3 style='display:inline;'>Unique files:</h3>".$unique."</table><hr>";
    }
    else
    {
      echo "<h3>not a valid dir $pack_name</h3>";  
    }
 }   

    echo $html_end;
    ob_end_flush();
?>
