<?php

// Useful functions 
    function ignorecasesort(&$array) {
     $separator="|<>|";
     for($i=0;$i<sizeof($array);$i++) { $array[$i]=strtolower($array[$i]).$separator.$array[$i]; }
     sort($array);
     for($i=0;$i<sizeof($array);$i++) { $t=$array[$i]; $t=explode($separator,$t); $array[$i]=$t[1]; }
    }  

    function getmicrotime(){
      list($usec, $sec) = explode(" ",microtime());
      return ((float)$usec + (float)$sec);
    }
    
    function HTML_code($c64filename)
    {
      return str_replace(array('_', '>' ,'<'), array('<-','&gt;','&lt;'), $c64filename);
    }
       
    function reduce_entry_name($file_entry)
    {
      $c64_filename = trim($file_entry,chr(160));
      $c64_filename = str_replace(chr(0),' ',$c64_filename);  // pc64 format thing...
      //remove spaces to get better hit i.e. "DEMO       /ABC" => "DEMO/ABC"      
      $c64_filename = preg_replace('/\s\s+/', ' ', $c64_filename);   
      $c64_filename = preg_replace(array('/\/\s/', '/\s\//'), '/', $c64_filename);    //  " /" -> "/", "/ " -> "/"
      // Remove spaces
      //$c64_filename = preg_replace('/\s\[/', '[', $c64_filename);    
      //$c64_filename = preg_replace('/\s\(/', '(', $c64_filename);    //  " (" -> "(" (other way is already done!)
      //$c64_filename = preg_replace('/\s\</', '<', $c64_filename);    //  " <" -> "<" (other way is already done!)
      //$c64_filename = preg_replace('/\.+/', '.', $c64_filename);     // remove multiple dots "...." -> "." 
      //$c64_filename = preg_replace('/\s\+/', '+', $c64_filename);    //  " +" -> "+" (other way is already done!)  
      // $c64_filename = preg_replace('/\s\{/', '{', $c64_filename);    //  " {" -> "{" (other way is already done!)
      
      $c64_filename = preg_replace(array('/\s\[/', '/\s\(/', '/\s\</', '/\.+/', '/\s\+/', '/\s\{/'), array('[','(','<','.','+','{'), $c64_filename); 
      $c64_filename = trim($c64_filename, "'");                      // "'filename'" -> "filename", just to get better hits!
      return $c64_filename;
    }

    function entry_name_fix($str)
    {
      $str = trim(str_replace('"', "'", $str));
      return preg_replace(array('/\[/', '/\]/', '/\>/', '/\</', '/\(/', '/\)/', '/\+/', '/\?/', '/\*/', '/\$/'  ), array('\[', '\]', '\>', '\<', '\(', '\)', '\+', '\?', '*', '\\\$' ), $str); 
    }


    function check($long,$short)
    {
      if ( (strlen($short)<=strlen($long)) AND (strlen($short)>0) )
      {
        $short = str_replace('+',' +',$short);
        $long = str_replace('+',' +',$long);
        $short = trim(str_replace('  ',' ',$short));
        $long = trim(str_replace('  ',' ',$long));
        $short = ltrim($short,".");

        $l = 0;   // offset long  string
        $s = 0;   // offset short string
        $rem = 0; // position to beginning of token (long)
        $r = "";  // result 
        while ( $s<(strlen($short)) ) 
        {
          // copy current char while equal, and increment all indeces
          if ($long[$l]==$short[$s])
            {
              $r.=$short[$s];$l++;$s++;$rem++;
            }
                    
          // else if abbreviation found "."/" " : "str.fighter" / "S FIGHTER"
          else if (($short[$s]=='.') OR ($short[$s]==' ') or ($short[$s]=='&') )
            {              
              $r .= $short[$s];
              $s++; if ($short[$s]==' '){$s++;} // increase s till next char
              $next = strpos($long, ' ', $l);   // get position to next space, if it exists
              if (!($next===false))
                {
                  // There is a next SPACE, increase l to next+1, and reset rem
                  $l=$next+1;$rem = 0;
                }                      
            }
                     
          // not equal "a"<>"b", STOP!
          else
            {
              $s = strlen($short);               // stop the while loop.
              $r = substr($r,0,strlen($r)-$rem); // remove nonmatching token
            }
          }
        $r .= substr($long, $l, strlen($s)-strlen($r)); // ensure result contains non matching tail
        }
        else
        {
          $r = $long; // if short>long, then return long.  
        } 
        return $r;
   }


   function is_az($str, $pos, $len)
   {
     // this function decides weather there is a LETTER [A..Z] to the
     // left or right of last found groub-abbrivation! 
     
     $LETTER_A = 64; // ord("A")-1
     $LETTER_Z = 91; // ord("Z")+1
     $result = false;

     $val = ord($str[$pos]);
     if ( ($val<=$LETTER_A) OR ($val>=$LETTER_Z)){
      $result = false;
     }        
     else
     {
      if ($pos>0){
        $val = ord($str[$pos-1]);
        if ( ($val>$LETTER_A) AND ($val<$LETTER_Z) ){
          $result = true;
        }
      }
      if(!$result){
       $pos += $len;
       if (($pos)<strlen($str)){
         $val = ord($str[$pos]);
         if ( ($val>$LETTER_A) AND ($val<$LETTER_Z) ){
          $result = true;          
         }
        }
      }
     }
     return $result;
   }

?>
